# 4. Solution architecture

## 4.1 General achitecture

The general architecture to implement this project consists of two main parts:
- Complex Event Processing in Java with Apache Flink with Apache Kafka as a connector
- Predictive Analysis in Python with h2o library for Machine Learning

As the data streams can have a huge size, Apache Flink is used to process the stream. Unlike other competitors (i.e. Spark), Flink supports realtime data streaming instead of using mini batches. Flink also supports CEP with the flink-cep library which enables the predefinition of classes and methods to set atterns.

The input and output of the two components are linked with Apache Kafka. Kafka is used for building real-time data pipelines and streaming apps. It is horizontally scalable, fault-tolerant, wicked fast, and runs in production in thousands of companies. We are using Kafka as a streaming source provider and can be used as a sink as well.
It works by providing Producers and Consumers, which are implement by various frameworks such as Apache Flink, Spark or a library in Python. By doing so, different programming languages and systems can be combined, which enables us to implement CEP and PA in completely different structures.
For testing purposes, a csv file containing streaming data was used. To emulate a data stream, the table will be parsed in python and used as a producer via Kafka.

## 4.2. Complex Event Processing Component
The input of the CEP component will be a data stream containing various events such as temperature. After being parsed into an object, it will be checked upon known pattern. Fig 1. shows three patterns to detect thunderstorms and additional properties.  
