
### 5.1.1 Machine Learn Algorithms 

To perform this analysis, we manually modeled and tested several algorithms provided by H2O library, among of them Decision Trees, Logistic Regression, Naive Bayes. We used the data from the first semester of the years 2015 to 2017 as training and validation data, and the data from January to June 2018 as test set. The selected variables were based on \citet{Banchero2015} and are presented on the After testing more than 5 different algorithms, none of them presented a good performance. Although the accuracy was higher than 98% (which could be considered as a very good performance), the false positive rate was around 60%. This evaluation measure is calculated as the number of incorrect positive predictions divided by the total number of negatives \cite{fawcett2006introduction}. In order to identify if there was a model that suited well to the data, we used the AutoML functionality provided by H2O. It uses Stacked Ensembles and includes automatic training and tuning of many models within a defined time-limit to identify which models have an optimal predictive performance \cite{documentation}. In this case the models selected by AutoML showed a slight better performance in accuracy. The best model was a GBM algorithm and achieved an accuracy of 98.7%. But again the false positive rate was close to 50%, which cannot be considered a good result.

### 5.1.2 Comparison of performance with CEP

After selecting the GBM model proposed by H2O AutoML, the algorithm was applied to the regions where CEP identified the trigger values for Convective Inhibition and Lifted Index. The next step was to compare the time needed to run the algorithm. Rhe scenario of filtering the regions with CEP showed a better performance, with an average time of processing of 0.8s, while to analyze the whole dataset was around 2s. There was no significant difference in accuracy and false positive rate levels
